Subject: Re: bug#32002: 24.4; Scroll bar start, end not correct

From: martin rudalics <[email-masked]>
Date: Fri, 06 Jul 2018 14:56:10 +0200

>>> gdb says that Emacs is getting jump events, not step events.
 >>>
 >>>    Thread 1 "emacs" hit Breakpoint 1, xg_scroll_callback (range=0x2f58740,
 >>>        scroll=GTK_SCROLL_JUMP, value=5637316.2000000002,
 >>>        user_data=0x1493c30 <bss_sbrk_buffer+8990864>) at xterm.c:5644
 >>
 >> Thanks.  I guess the issue now moves to GTK-land: why do we get jump
 >> events when you click on the steppers?  Maybe someone who knows GTK
 >> can answer that.
 >
 > It looks like GTK sends GTK_SCROLL_JUMP everytime the position of the
 > scrollbar thumb is changed, regardless of how you change it. I think
 > it can *also* send events when you click the stepper, but I suspect
 > you then get two events, with no easy way to distinguish them. Iʼd
 > test, but my theme doesnʼt have steppers.

Here I'm called back with exactly one GTK_SCROLL_STEP notification as

#0  xg_scroll_callback (range=0x183a3b0, scroll=GTK_SCROLL_STEP_FORWARD, value=244073, user_data=0x15410a0) at ../../src/xterm.c:5673

Otherwise, IIUC nothing would happen since GTK_SCROLL_JUMP expects
that the mouse has been grabbed in order to send a scroll_bar_event.
But maybe I'm misreading the code.

martin